Package java.lang

## Class String

- java.lang.Object
- - java.lang.String

- All Implemented Interfaces:
    `Serializable`, `CharSequence`, `Comparable<String>`

      public final class String
      extends Object
      implements Serializable, Comparable<String>, CharSequence

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static Comparator<String>` | `CASE_INSENSITIVE_ORDER` | A Comparator that orders `String` objects as by `compareToIgnoreCase`.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `String()` | Initializes a newly created `String` object so that it represents an empty character sequence.
    `String​(byte[] bytes)` | Constructs a new `String` by decoding the specified array of bytes using the platform's default charset.
    `String​(byte[] bytes, int offset, int length)` | Constructs a new `String` by decoding the specified subarray of bytes using the platform's default charset.
    `String​(byte[] bytes, int offset, int length, String charsetName)` | Constructs a new `String` by decoding the specified subarray of bytes using the specified charset.
    `String​(byte[] bytes, String charsetName)` | Constructs a new `String` by decoding the specified array of bytes using the specified charset.
    `String​(char[] value)` | Allocates a new `String` so that it represents the sequence of characters currently contained in the character array argument.
    `String​(char[] value, int offset, int count)` | Allocates a new `String` that contains characters from a subarray of the character array argument.
    `String​(String original)` | Initializes a newly created `String` object so that it represents the same sequence of characters as the argument; in other words, the newly created string is a copy of the argument string.
    `String​(StringBuffer buffer)` | Allocates a new string that contains the sequence of characters currently contained in the string buffer argument.
    `String​(StringBuilder builder)` | Allocates a new string that contains the sequence of characters currently contained in the string builder argument.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `char` | `charAt​(int index)` | Returns the `char` value at the specified index.
    `int` | `compareTo​(String anotherString)` | Compares two strings lexicographically.
    `int` | `compareToIgnoreCase​(String str)` | Compares two strings lexicographically, ignoring case differences.
    `String` | `concat​(String str)` | Concatenates the specified string to the end of this string.
    `boolean` | `contains​(CharSequence s)` | Returns true if and only if this string contains the specified sequence of char values.
    `boolean` | `contentEquals​(CharSequence cs)` | Compares this string to the specified `CharSequence`.
    `boolean` | `contentEquals​(StringBuffer sb)` | Compares this string to the specified `StringBuffer`.
    `static String` | `copyValueOf​(char[] data)` | Returns a String that represents the character sequence in the array specified.
    `static String` | `copyValueOf​(char[] data, int offset, int count)` | Returns a String that represents the character sequence in the array specified.
    `boolean` | `endsWith​(String suffix)` | Tests if this string ends with the specified suffix.
    `boolean` | `equals​(Object anObject)` | Compares this string to the specified object.
    `boolean` | `equalsIgnoreCase​(String anotherString)` | Compares this `String` to another `String`, ignoring case considerations.
    `byte[]` | `getBytes()` | Encodes this `String` into a sequence of bytes using the platform's default charset, storing the result into a new byte array.
    `byte[]` | `getBytes​(String charsetName)` | Encodes this `String` into a sequence of bytes using the named charset, storing the result into a new byte array.
    `void` | `getChars​(int srcBegin, int srcEnd, char[] dst, int dstBegin)` | Copies characters from this string into the destination character array.
    `int` | `hashCode()` | Returns a hash code for this string.
    `int` | `indexOf​(int ch)` | Returns the index within this string of the first occurrence of the specified character.
    `int` | `indexOf​(int ch, int fromIndex)` | Returns the index within this string of the first occurrence of the specified character, starting the search at the specified index.
    `int` | `indexOf​(String str)` | Returns the index within this string of the first occurrence of the specified substring.
    `int` | `indexOf​(String str, int fromIndex)` | Returns the index within this string of the first occurrence of the specified substring, starting at the specified index.
    `String` | `intern()` | Returns a canonical representation for the string object.
    `boolean` | `isEmpty()` | Returns `true` if, and only if, `length()` is `0`.
    `int` | `lastIndexOf​(int ch)` | Returns the index within this string of the last occurrence of the specified character.
    `int` | `lastIndexOf​(int ch, int fromIndex)` | Returns the index within this string of the last occurrence of the specified character, searching backward starting at the specified index.
    `int` | `lastIndexOf​(String str)` | Returns the index within this string of the last occurrence of the specified substring.
    `int` | `lastIndexOf​(String str, int fromIndex)` | Returns the index within this string of the last occurrence of the specified substring, searching backward starting at the specified index.
    `int` | `length()` | Returns the length of this string.
    `boolean` | `regionMatches​(boolean ignoreCase, int toffset, String other, int ooffset, int len)` | Tests if two string regions are equal.
    `boolean` | `regionMatches​(int toffset, String other, int ooffset, int len)` | Tests if two string regions are equal.
    `String` | `replace​(char oldChar, char newChar)` | Returns a new string resulting from replacing all occurrences of `oldChar` in this string with `newChar`.
    `String` | `replace​(CharSequence target, CharSequence replacement)` | Replaces each substring of this string that matches the literal target sequence with the specified literal replacement sequence.
    `boolean` | `startsWith​(String prefix)` | Tests if this string starts with the specified prefix.
    `boolean` | `startsWith​(String prefix, int toffset)` | Tests if the substring of this string beginning at the specified index starts with the specified prefix.
    `CharSequence` | `subSequence​(int beginIndex, int endIndex)` | Returns a new character sequence that is a subsequence of this sequence.
    `String` | `substring​(int beginIndex)` | Returns a new string that is a substring of this string.
    `String` | `substring​(int beginIndex, int endIndex)` | Returns a new string that is a substring of this string.
    `char[]` | `toCharArray()` | Converts this string to a new character array.
    `String` | `toLowerCase()` | Converts all of the characters in this `String` to lower case using the rules of the default locale.
    `String` | `toString()` | This object (which is already a string!) is itself returned.
    `String` | `toUpperCase()` | Converts all of the characters in this `String` to upper case using the rules of the default locale.
    `String` | `trim()` | Returns a copy of the string, with leading and trailing whitespace omitted.
    `static String` | `valueOf​(boolean b)` | Returns the string representation of the `boolean` argument.
    `static String` | `valueOf​(char c)` | Returns the string representation of the `char` argument.
    `static String` | `valueOf​(char[] data)` | Returns the string representation of the `char` array argument.
    `static String` | `valueOf​(char[] data, int offset, int count)` | Returns the string representation of a specific subarray of the `char` array argument.
    `static String` | `valueOf​(double d)` | Returns the string representation of the `double` argument.
    `static String` | `valueOf​(float f)` | Returns the string representation of the `float` argument.
    `static String` | `valueOf​(int i)` | Returns the string representation of the `int` argument.
    `static String` | `valueOf​(long l)` | Returns the string representation of the `long` argument.
    `static String` | `valueOf​(Object obj)` | Returns the string representation of the `Object` argument.

    - ### Methods inherited from class java.lang.Object

      `clone, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### CASE_INSENSITIVE_ORDER

          public static final Comparator<String> CASE_INSENSITIVE_ORDER

      A Comparator that orders `String` objects as by `compareToIgnoreCase`. This comparator is serializable.

  - ### Constructor Detail

    - #### String

          public String()

      Initializes a newly created `String` object so that it represents an empty character sequence. Note that use of this constructor is unnecessary since Strings are immutable.

    - #### String

          public String​(byte[] bytes)

      Constructs a new `String` by decoding the specified array of bytes using the platform's default charset. The length of the new `String` is a function of the charset, and hence may not be equal to the length of the byte array.
      Parameters:
        `bytes` - The bytes to be decoded into characters

    - #### String

          public String​(byte[] bytes,
                        int offset,
                        int length)

      Constructs a new `String` by decoding the specified subarray of bytes using the platform's default charset. The length of the new `String` is a function of the charset, and hence may not be equal to the length of the subarray.
      Parameters:
        `bytes` - The bytes to be decoded into characters
        `offset` - The index of the first byte to decode
        `length` - The number of bytes to decode
      Throws:
        `IndexOutOfBoundsException` - If the `offset` and the `length` arguments index characters outside the bounds of the `bytes` array

    - #### String

          public String​(byte[] bytes,
                        int offset,
                        int length,
                        String charsetName)
                 throws UnsupportedEncodingException

      Constructs a new `String` by decoding the specified subarray of bytes using the specified charset. The length of the new `String` is a function of the charset, and hence may not be equal to the length of the subarray.
      Parameters:
        `bytes` - The bytes to be decoded into characters
        `offset` - The index of the first byte to decode
        `length` - The number of bytes to decode
        `charsetName` - The name of a supported charset
      Throws:
        `UnsupportedEncodingException` - If the named charset is not supported
        `IndexOutOfBoundsException` - If the `offset` and `length` arguments index characters outside the bounds of the `bytes` array

    - #### String

          public String​(byte[] bytes,
                        String charsetName)
                 throws UnsupportedEncodingException

      Constructs a new `String` by decoding the specified array of bytes using the specified charset. The length of the new `String` is a function of the charset, and hence may not be equal to the length of the byte array.
      Parameters:
        `bytes` - The bytes to be decoded into characters
        `charsetName` - The name of a supported charset
      Throws:
        `UnsupportedEncodingException` - If the named charset is not supported

    - #### String

          public String​(char[] value)

      Allocates a new `String` so that it represents the sequence of characters currently contained in the character array argument. The contents of the character array are copied; subsequent modification of the character array does not affect the newly created string.
      Parameters:
        `value` - The initial value of the string

    - #### String

          public String​(char[] value,
                        int offset,
                        int count)

      Allocates a new `String` that contains characters from a subarray of the character array argument. The `offset` argument is the index of the first character of the subarray and the `count` argument specifies the length of the subarray. The contents of the subarray are copied; subsequent modification of the character array does not affect the newly created string.
      Parameters:
        `value` - Array that is the source of characters
        `offset` - The initial offset
        `count` - The length
      Throws:
        `IndexOutOfBoundsException` - If the `offset` and `count` arguments index characters outside the bounds of the `value` array

    - #### String

          public String​(String original)

      Initializes a newly created `String` object so that it represents the same sequence of characters as the argument; in other words, the newly created string is a copy of the argument string. Unless an explicit copy of `original` is needed, use of this constructor is unnecessary since Strings are immutable.
      Parameters:
        `original` - A `String`

    - #### String

          public String​(StringBuffer buffer)

      Allocates a new string that contains the sequence of characters currently contained in the string buffer argument. The contents of the string buffer are copied; subsequent modification of the string buffer does not affect the newly created string.
      Parameters:
        `buffer` - A `StringBuffer`

    - #### String

          public String​(StringBuilder builder)

      Allocates a new string that contains the sequence of characters currently contained in the string builder argument. The contents of the string builder are copied; subsequent modification of the string builder does not affect the newly created string.

      This constructor is provided to ease migration to `StringBuilder`. Obtaining a string from a string builder via the `toString` method is likely to run faster and is generally preferred.

      Parameters:
        `builder` - A `StringBuilder`

  - ### Method Detail

    - #### copyValueOf

          public static String copyValueOf​(char[] data)

      Returns a String that represents the character sequence in the array specified.
      Parameters:
        `data` - the character array.
      Returns:
        a `String` that contains the characters of the character array.

    - #### copyValueOf

          public static String copyValueOf​(char[] data,
                                           int offset,
                                           int count)

      Returns a String that represents the character sequence in the array specified.
      Parameters:
        `data` - the character array.
        `offset` - initial offset of the subarray.
        `count` - length of the subarray.
      Returns:
        a `String` that contains the characters of the specified subarray of the character array.

    - #### valueOf

          public static String valueOf​(boolean b)

      Returns the string representation of the `boolean` argument.
      Parameters:
        `b` - a `boolean`.
      Returns:
        if the argument is `true`, a string equal to `"true"` is returned; otherwise, a string equal to `"false"` is returned.

    - #### valueOf

          public static String valueOf​(char c)

      Returns the string representation of the `char` argument.
      Parameters:
        `c` - a `char`.
      Returns:
        a string of length `1` containing as its single character the argument `c`.

    - #### valueOf

          public static String valueOf​(char[] data)

      Returns the string representation of the `char` array argument. The contents of the character array are copied; subsequent modification of the character array does not affect the newly created string.
      Parameters:
        `data` - a `char` array.
      Returns:
        a newly allocated string representing the same sequence of characters contained in the character array argument.

    - #### valueOf

          public static String valueOf​(char[] data,
                                       int offset,
                                       int count)

      Returns the string representation of a specific subarray of the `char` array argument.

      The `offset` argument is the index of the first character of the subarray. The `count` argument specifies the length of the subarray. The contents of the subarray are copied; subsequent modification of the character array does not affect the newly created string.

      Parameters:
        `data` - the character array.
        `offset` - the initial offset into the value of the `String`.
        `count` - the length of the value of the `String`.
      Returns:
        a string representing the sequence of characters contained in the subarray of the character array argument.
      Throws:
        `IndexOutOfBoundsException` - if `offset` is negative, or `count` is negative, or `offset+count` is larger than `data.length`.

    - #### valueOf

          public static String valueOf​(double d)

      Returns the string representation of the `double` argument.

      The representation is exactly the one returned by the `Double.toString` method of one argument.

      Parameters:
        `d` - a `double`.
      Returns:
        a string representation of the `double` argument.
      See Also:
        `Double.toString(double)`

    - #### valueOf

          public static String valueOf​(float f)

      Returns the string representation of the `float` argument.

      The representation is exactly the one returned by the `Float.toString` method of one argument.

      Parameters:
        `f` - a `float`.
      Returns:
        a string representation of the `float` argument.
      See Also:
        `Float.toString(float)`

    - #### valueOf

          public static String valueOf​(int i)

      Returns the string representation of the `int` argument.

      The representation is exactly the one returned by the `Integer.toString` method of one argument.

      Parameters:
        `i` - an `int`.
      Returns:
        a string representation of the `int` argument.
      See Also:
        `Integer.toString(int, int)`

    - #### valueOf

          public static String valueOf​(long l)

      Returns the string representation of the `long` argument.

      The representation is exactly the one returned by the `Long.toString` method of one argument.

      Parameters:
        `l` - a `long`.
      Returns:
        a string representation of the `long` argument.
      See Also:
        `Long.toString(long)`

    - #### valueOf

          public static String valueOf​(@Nullable
                                       Object obj)

      Returns the string representation of the `Object` argument.
      Parameters:
        `obj` - an `Object`.
      Returns:
        if the argument is `null`, then a string equal to `"null"`; otherwise, the value of `obj.toString()` is returned.
      See Also:
        `Object.toString()`

    - #### charAt

          public char charAt​(int index)

      Returns the `char` value at the specified index. An index ranges from `0` to `length() - 1`. The first `char` value of the sequence is at index `0`, the next at index `1`, and so on, as for array indexing.
      Specified by:
        `charAt` in interface `CharSequence`
      Parameters:
        `index` - the index of the `char` value.
      Returns:
        the `char` value at the specified index of this string. The first `char` value is at index `0`.
      Throws:
        `IndexOutOfBoundsException` - if the `index` argument is negative or not less than the length of this string.

    - #### compareTo

          public int compareTo​(String anotherString)

      Compares two strings lexicographically. The comparison is based on the Unicode value of each character in the strings. The character sequence represented by this `String` object is compared lexicographically to the character sequence represented by the argument string. The result is a negative integer if this `String` object lexicographically precedes the argument string. The result is a positive integer if this `String` object lexicographically follows the argument string. The result is zero if the strings are equal; `compareTo` returns `0` exactly when the `equals(Object)` method would return `true`.

      This is the definition of lexicographic ordering. If two strings are different, then either they have different characters at some index that is a valid index for both strings, or their lengths are different, or both. If they have different characters at one or more index positions, let k be the smallest such index; then the string whose character at position k has the smaller value, as determined by using the < operator, lexicographically precedes the other string. In this case, `compareTo` returns the difference of the two character values at position `k` in the two string -- that is, the value:

      >      this.charAt(k) - anotherString.charAt(k)

      If there is no index position at which they differ, then the shorter string lexicographically precedes the longer string. In this case, `compareTo` returns the difference of the lengths of the strings -- that is, the value:

      >      this.length() - anotherString.length()

      Specified by:
        `compareTo` in interface `Comparable<String>`
      Parameters:
        `anotherString` - the `String` to be compared.
      Returns:
        the value `0` if the argument string is equal to this string; a value less than `0` if this string is lexicographically less than the string argument; and a value greater than `0` if this string is lexicographically greater than the string argument.

    - #### compareToIgnoreCase

          public int compareToIgnoreCase​(String str)

      Compares two strings lexicographically, ignoring case differences. This method returns an integer whose sign is that of calling `compareTo` with normalized versions of the strings where case differences have been eliminated by calling `Character.toLowerCase(Character.toUpperCase(character))` on each character.

      Note that this method does not take locale into account, and will result in an unsatisfactory ordering for certain locales. The java.text package provides collators to allow locale-sensitive ordering.

      Parameters:
        `str` - the `String` to be compared.
      Returns:
        a negative integer, zero, or a positive integer as the specified String is greater than, equal to, or less than this String, ignoring case considerations.

    - #### concat

          public String concat​(String str)

      Concatenates the specified string to the end of this string.

      If the length of the argument string is `0`, then this `String` object is returned. Otherwise, a new `String` object is created, representing a character sequence that is the concatenation of the character sequence represented by this `String` object and the character sequence represented by the argument string.

      Examples:

      >      "cares".concat("s") returns "caress"
      >      "to".concat("get").concat("her") returns "together"

      Parameters:
        `str` - the `String` that is concatenated to the end of this `String`.
      Returns:
        a string that represents the concatenation of this object's characters followed by the string argument's characters.

    - #### contains

          public boolean contains​(CharSequence s)

      Returns true if and only if this string contains the specified sequence of char values.
      Parameters:
        `s` - the sequence to search for
      Returns:
        true if this string contains `s`, false otherwise
      Throws:
        `NullPointerException` - if `s` is `null`

    - #### contentEquals

          public boolean contentEquals​(CharSequence cs)

      Compares this string to the specified `CharSequence`. The result is `true` if and only if this `String` represents the same sequence of char values as the specified sequence.
      Parameters:
        `cs` - The sequence to compare this `String` against
      Returns:
        `true` if this `String` represents the same sequence of char values as the specified sequence, `false` otherwise

    - #### contentEquals

          public boolean contentEquals​(StringBuffer sb)

      Compares this string to the specified `StringBuffer`. The result is `true` if and only if this `String` represents the same sequence of characters as the specified `StringBuffer`.
      Parameters:
        `sb` - The `StringBuffer` to compare this `String` against
      Returns:
        `true` if this `String` represents the same sequence of characters as the specified `StringBuffer`, `false` otherwise

    - #### endsWith

          public boolean endsWith​(String suffix)

      Tests if this string ends with the specified suffix.
      Parameters:
        `suffix` - the suffix.
      Returns:
        `true` if the character sequence represented by the argument is a suffix of the character sequence represented by this object; `false` otherwise. Note that the result will be `true` if the argument is the empty string or is equal to this `String` object as determined by the `equals(Object)` method.

    - #### equals

          public boolean equals​(@Nullable
                                Object anObject)

      Compares this string to the specified object. The result is `true` if and only if the argument is not `null` and is a `String` object that represents the same sequence of characters as this object.
      Overrides:
        `equals` in class `Object`
      Parameters:
        `anObject` - The object to compare this `String` against
      Returns:
        `true` if the given object represents a `String` equivalent to this string, `false` otherwise
      See Also:
        `compareTo(String)`, `equalsIgnoreCase(String)`

    - #### equalsIgnoreCase

          public boolean equalsIgnoreCase​(String anotherString)

      Compares this `String` to another `String`, ignoring case considerations. Two strings are considered equal ignoring case if they are of the same length and corresponding characters in the two strings are equal ignoring case.

      Two characters `c1` and `c2` are considered the same ignoring case if at least one of the following is true:

      - The two characters are the same (as compared by the `==` operator)
      - Applying the method `Character.toUpperCase(char)` to each character produces the same result
      - Applying the method `Character.toLowerCase(char)` to each character produces the same result
      Parameters:
        `anotherString` - The `String` to compare this `String` against
      Returns:
        `true` if the argument is not `null` and it represents an equivalent `String` ignoring case; `false` otherwise
      See Also:
        `equals(Object)`

    - #### getBytes

          public byte[] getBytes()

      Encodes this `String` into a sequence of bytes using the platform's default charset, storing the result into a new byte array.
      Returns:
        The resultant byte array

    - #### getBytes

          public byte[] getBytes​(String charsetName)
                          throws UnsupportedEncodingException

      Encodes this `String` into a sequence of bytes using the named charset, storing the result into a new byte array.
      Parameters:
        `charsetName` - The name of a supported charset
      Returns:
        The resultant byte array
      Throws:
        `UnsupportedEncodingException` - If the named charset is not supported

    - #### getChars

          public void getChars​(int srcBegin,
                               int srcEnd,
                               char[] dst,
                               int dstBegin)

      Copies characters from this string into the destination character array.

      The first character to be copied is at index `srcBegin`; the last character to be copied is at index `srcEnd-1` (thus the total number of characters to be copied is `srcEnd-srcBegin`). The characters are copied into the subarray of `dst` starting at index `dstBegin` and ending at index:

      >      dstbegin + (srcEnd - srcBegin) - 1

      Parameters:
        `srcBegin` - index of the first character in the string to copy.
        `srcEnd` - index after the last character in the string to copy.
        `dst` - the destination array.
        `dstBegin` - the start offset in the destination array.
      Throws:
        `IndexOutOfBoundsException` - If any of the following is true:
        - `srcBegin` is negative.
        - `srcBegin` is greater than `srcEnd`
        - `srcEnd` is greater than the length of this string
        - `dstBegin` is negative
        - `dstBegin+(srcEnd-srcBegin)` is larger than `dst.length`

    - #### hashCode

          public int hashCode()

      Returns a hash code for this string. The hash code for a `String` object is computed as

      >      s[0]*31^(n-1) + s[1]*31^(n-2) + ... + s[n-1]

      using `int` arithmetic, where `s[i]` is the ith character of the string, `n` is the length of the string, and `^` indicates exponentiation. (The hash value of the empty string is zero.)
      Overrides:
        `hashCode` in class `Object`
      Returns:
        a hash code value for this object.
      See Also:
        `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`

    - #### indexOf

          public int indexOf​(int ch)

      Returns the index within this string of the first occurrence of the specified character. If a character with value `ch` occurs in the character sequence represented by this `String` object, then the index (in Unicode code units) of the first such occurrence is returned. For values of `ch` in the range from 0 to 0xFFFF (inclusive), this is the smallest value k such that:

      >      this.charAt(k) == ch

      is true. For other values of `ch`, it is the smallest value k such that:

      >      this.codePointAt(k) == ch

      is true. In either case, if no such character occurs in this string, then `-1` is returned.
      Parameters:
        `ch` - a character (Unicode code point).
      Returns:
        the index of the first occurrence of the character in the character sequence represented by this object, or `-1` if the character does not occur.

    - #### indexOf

          public int indexOf​(int ch,
                             int fromIndex)

      Returns the index within this string of the first occurrence of the specified character, starting the search at the specified index.

      If a character with value `ch` occurs in the character sequence represented by this `String` object at an index no smaller than `fromIndex`, then the index of the first such occurrence is returned. For values of `ch` in the range from 0 to 0xFFFF (inclusive), this is the smallest value k such that:

      >      (this.charAt(k) == ch) && (k >= fromIndex)

      is true. For other values of `ch`, it is the smallest value k such that:

      >      (this.codePointAt(k) == ch) && (k >= fromIndex)

      is true. In either case, if no such character occurs in this string at or after position `fromIndex`, then `-1` is returned.

      There is no restriction on the value of `fromIndex`. If it is negative, it has the same effect as if it were zero: this entire string may be searched. If it is greater than the length of this string, it has the same effect as if it were equal to the length of this string: `-1` is returned.

      All indices are specified in `char` values (Unicode code units).

      Parameters:
        `ch` - a character (Unicode code point).
        `fromIndex` - the index to start the search from.
      Returns:
        the index of the first occurrence of the character in the character sequence represented by this object that is greater than or equal to `fromIndex`, or `-1` if the character does not occur.

    - #### indexOf

          public int indexOf​(String str)

      Returns the index within this string of the first occurrence of the specified substring.

      The returned index is the smallest value k for which:

      >      this.startsWith(str, k)

      If no such value of k exists, then `-1` is returned.
      Parameters:
        `str` - the substring to search for.
      Returns:
        the index of the first occurrence of the specified substring, or `-1` if there is no such occurrence.

    - #### indexOf

          public int indexOf​(String str,
                             int fromIndex)

      Returns the index within this string of the first occurrence of the specified substring, starting at the specified index.

      The returned index is the smallest value k for which:

      >      k >= fromIndex && this.startsWith(str, k)

      If no such value of k exists, then `-1` is returned.
      Parameters:
        `str` - the substring to search for.
        `fromIndex` - the index from which to start the search.
      Returns:
        the index of the first occurrence of the specified substring, starting at the specified index, or `-1` if there is no such occurrence.

    - #### intern

          public String intern()

      Returns a canonical representation for the string object.

      A pool of strings, initially empty, is maintained privately by the class `String`.

      When the intern method is invoked, if the pool already contains a string equal to this `String` object as determined by the `equals(Object)` method, then the string from the pool is returned. Otherwise, this `String` object is added to the pool and a reference to this `String` object is returned.

      It follows that for any two strings `s` and `t`, `s.intern() == t.intern()` is `true` if and only if `s.equals(t)` is `true`.

      All literal strings and string-valued constant expressions are interned. String literals are defined in section 3.10.5 of the The Java™ Language Specification.

      Returns:
        a string that has the same contents as this string, but is guaranteed to be from a pool of unique strings.

    - #### isEmpty

          public boolean isEmpty()

      Returns `true` if, and only if, `length()` is `0`.
      Returns:
        `true` if `length()` is `0`, otherwise `false`

    - #### lastIndexOf

          public int lastIndexOf​(int ch)

      Returns the index within this string of the last occurrence of the specified character. For values of `ch` in the range from 0 to 0xFFFF (inclusive), the index (in Unicode code units) returned is the largest value k such that:

      >      this.charAt(k) == ch

      is true. For other values of `ch`, it is the largest value k such that:

      >      this.codePointAt(k) == ch

      is true. In either case, if no such character occurs in this string, then `-1` is returned. The `String` is searched backwards starting at the last character.
      Parameters:
        `ch` - a character (Unicode code point).
      Returns:
        the index of the last occurrence of the character in the character sequence represented by this object, or `-1` if the character does not occur.

    - #### lastIndexOf

          public int lastIndexOf​(int ch,
                                 int fromIndex)

      Returns the index within this string of the last occurrence of the specified character, searching backward starting at the specified index. For values of `ch` in the range from 0 to 0xFFFF (inclusive), the index returned is the largest value k such that:

      >      (this.charAt(k) == ch) && (k <= fromIndex)

      is true. For other values of `ch`, it is the largest value k such that:

      >      (this.codePointAt(k) == ch) && (k <= fromIndex)

      is true. In either case, if no such character occurs in this string at or before position `fromIndex`, then `-1` is returned.

      All indices are specified in `char` values (Unicode code units).

      Parameters:
        `ch` - a character (Unicode code point).
        `fromIndex` - the index to start the search from. There is no restriction on the value of `fromIndex`. If it is greater than or equal to the length of this string, it has the same effect as if it were equal to one less than the length of this string: this entire string may be searched. If it is negative, it has the same effect as if it were -1: -1 is returned.
      Returns:
        the index of the last occurrence of the character in the character sequence represented by this object that is less than or equal to `fromIndex`, or `-1` if the character does not occur before that point.

    - #### lastIndexOf

          public int lastIndexOf​(String str)

      Returns the index within this string of the last occurrence of the specified substring. The last occurrence of the empty string "" is considered to occur at the index value `this.length()`.

      The returned index is the largest value k for which:

      >      this.startsWith(str, k)

      If no such value of k exists, then `-1` is returned.
      Parameters:
        `str` - the substring to search for.
      Returns:
        the index of the last occurrence of the specified substring, or `-1` if there is no such occurrence.

    - #### lastIndexOf

          public int lastIndexOf​(String str,
                                 int fromIndex)

      Returns the index within this string of the last occurrence of the specified substring, searching backward starting at the specified index.

      The returned index is the largest value k for which:

      >      k <= fromIndex && this.startsWith(str, k)

      If no such value of k exists, then `-1` is returned.
      Parameters:
        `str` - the substring to search for.
        `fromIndex` - the index to start the search from.
      Returns:
        the index of the last occurrence of the specified substring, searching backward from the specified index, or `-1` if there is no such occurrence.

    - #### length

          public int length()

      Returns the length of this string. The length is equal to the number of Unicode code units in the string.
      Specified by:
        `length` in interface `CharSequence`
      Returns:
        the length of the sequence of characters represented by this object.

    - #### regionMatches

          public boolean regionMatches​(boolean ignoreCase,
                                       int toffset,
                                       String other,
                                       int ooffset,
                                       int len)

      Tests if two string regions are equal.

      A substring of this `String` object is compared to a substring of the argument `other`. The result is `true` if these substrings represent character sequences that are the same, ignoring case if and only if `ignoreCase` is true. The substring of this `String` object to be compared begins at index `toffset` and has length `len`. The substring of `other` to be compared begins at index `ooffset` and has length `len`. The result is `false` if and only if at least one of the following is true:

      - `toffset` is negative.
      - `ooffset` is negative.
      - `toffset+len` is greater than the length of this `String` object.
      - `ooffset+len` is greater than the length of the other argument.
      - `ignoreCase` is `false` and there is some nonnegative integer k less than `len` such that:

        >      this.charAt(toffset + k) != other.charAt(ooffset + k)

      - `ignoreCase` is `true` and there is some nonnegative integer k less than `len` such that:

        >      Character.toLowerCase(this.charAt(toffset + k)) != Character.toLowerCase(other.charAt(ooffset + k))

        and:

        >      Character.toUpperCase(this.charAt(toffset + k)) != Character.toUpperCase(other.charAt(ooffset + k))

      Parameters:
        `ignoreCase` - if `true`, ignore case when comparing characters.
        `toffset` - the starting offset of the subregion in this string.
        `other` - the string argument.
        `ooffset` - the starting offset of the subregion in the string argument.
        `len` - the number of characters to compare.
      Returns:
        `true` if the specified subregion of this string matches the specified subregion of the string argument; `false` otherwise. Whether the matching is exact or case insensitive depends on the `ignoreCase` argument.

    - #### regionMatches

          public boolean regionMatches​(int toffset,
                                       String other,
                                       int ooffset,
                                       int len)

      Tests if two string regions are equal.

      A substring of this `String` object is compared to a substring of the argument other. The result is true if these substrings represent identical character sequences. The substring of this `String` object to be compared begins at index `toffset` and has length `len`. The substring of other to be compared begins at index `ooffset` and has length `len`. The result is `false` if and only if at least one of the following is true:

      - `toffset` is negative.
      - `ooffset` is negative.
      - `toffset+len` is greater than the length of this `String` object.
      - `ooffset+len` is greater than the length of the other argument.
      - There is some nonnegative integer k less than `len` such that: `this.charAt(toffset+k) != other.charAt(ooffset+k)`
      Parameters:
        `toffset` - the starting offset of the subregion in this string.
        `other` - the string argument.
        `ooffset` - the starting offset of the subregion in the string argument.
        `len` - the number of characters to compare.
      Returns:
        `true` if the specified subregion of this string exactly matches the specified subregion of the string argument; `false` otherwise.

    - #### replace

          public String replace​(char oldChar,
                                char newChar)

      Returns a new string resulting from replacing all occurrences of `oldChar` in this string with `newChar`.

      If the character `oldChar` does not occur in the character sequence represented by this `String` object, then a reference to this `String` object is returned. Otherwise, a new `String` object is created that represents a character sequence identical to the character sequence represented by this `String` object, except that every occurrence of `oldChar` is replaced by an occurrence of `newChar`.

      Examples:

      >      "mesquite in your cellar".replace('e', 'o')
      >              returns "mosquito in your collar"
      >      "the war of baronets".replace('r', 'y')
      >              returns "the way of bayonets"
      >      "sparring with a purple porpoise".replace('p', 't')
      >              returns "starring with a turtle tortoise"
      >      "JonL".replace('q', 'x') returns "JonL" (no change)

      Parameters:
        `oldChar` - the old character.
        `newChar` - the new character.
      Returns:
        a string derived from this string by replacing every occurrence of `oldChar` with `newChar`.

    - #### replace

          public String replace​(CharSequence target,
                                CharSequence replacement)

      Replaces each substring of this string that matches the literal target sequence with the specified literal replacement sequence. The replacement proceeds from the beginning of the string to the end, for example, replacing "aa" with "b" in the string "aaa" will result in "ba" rather than "ab".
      Parameters:
        `target` - The sequence of char values to be replaced
        `replacement` - The replacement sequence of char values
      Returns:
        The resulting string
      Throws:
        `NullPointerException` - if `target` or `replacement` is `null`.

    - #### startsWith

          public boolean startsWith​(String prefix)

      Tests if this string starts with the specified prefix.
      Parameters:
        `prefix` - the prefix.
      Returns:
        `true` if the character sequence represented by the argument is a prefix of the character sequence represented by this string; `false` otherwise. Note also that `true` will be returned if the argument is an empty string or is equal to this `String` object as determined by the `equals(Object)` method.

    - #### startsWith

          public boolean startsWith​(String prefix,
                                    int toffset)

      Tests if the substring of this string beginning at the specified index starts with the specified prefix.
      Parameters:
        `prefix` - the prefix.
        `toffset` - where to begin looking in this string.
      Returns:
        `true` if the character sequence represented by the argument is a prefix of the substring of this object starting at index `toffset`; `false` otherwise. The result is `false` if `toffset` is negative or greater than the length of this `String` object; otherwise the result is the same as the result of the expression

                     this.substring(toffset).startsWith(prefix)

    - #### subSequence

          public CharSequence subSequence​(int beginIndex,
                                          int endIndex)

      Returns a new character sequence that is a subsequence of this sequence.

      An invocation of this method of the form

      >      str.subSequence(begin, end)

      behaves in exactly the same way as the invocation

      >      str.substring(begin, end)

      This method is defined so that the `String` class can implement the `CharSequence` interface.
      Specified by:
        `subSequence` in interface `CharSequence`
      Parameters:
        `beginIndex` - the begin index, inclusive.
        `endIndex` - the end index, exclusive.
      Returns:
        the specified subsequence.
      Throws:
        `IndexOutOfBoundsException` - if `beginIndex` or `endIndex` are negative, if `endIndex` is greater than `length()`, or if `beginIndex` is greater than `startIndex`

    - #### substring

          public String substring​(int beginIndex)

      Returns a new string that is a substring of this string. The substring begins with the character at the specified index and extends to the end of this string.

      Examples:

      >      "unhappy".substring(2) returns "happy"
      >      "Harbison".substring(3) returns "bison"
      >      "emptiness".substring(9) returns "" (an empty string)

      Parameters:
        `beginIndex` - the beginning index, inclusive.
      Returns:
        the specified substring.
      Throws:
        `IndexOutOfBoundsException` - if `beginIndex` is negative or larger than the length of this `String` object.

    - #### substring

          public String substring​(int beginIndex,
                                  int endIndex)

      Returns a new string that is a substring of this string. The substring begins at the specified `beginIndex` and extends to the character at index `endIndex - 1`. Thus the length of the substring is `endIndex-beginIndex`.

      Examples:

      >      "hamburger".substring(4, 8) returns "urge"
      >      "smiles".substring(1, 5) returns "mile"

      Parameters:
        `beginIndex` - the beginning index, inclusive.
        `endIndex` - the ending index, exclusive.
      Returns:
        the specified substring.
      Throws:
        `IndexOutOfBoundsException` - if the `beginIndex` is negative, or `endIndex` is larger than the length of this `String` object, or `beginIndex` is larger than `endIndex`.

    - #### toCharArray

          public char[] toCharArray()

      Converts this string to a new character array.
      Returns:
        a newly allocated character array whose length is the length of this string and whose contents are initialized to contain the character sequence represented by this string.

    - #### toLowerCase

          public String toLowerCase()

      Converts all of the characters in this `String` to lower case using the rules of the default locale. This is equivalent to calling `toLowerCase(Locale.getDefault())`.
      Returns:
        the `String`, converted to lowercase.

    - #### toString

          public String toString()

      This object (which is already a string!) is itself returned.
      Specified by:
        `toString` in interface `CharSequence`
      Overrides:
        `toString` in class `Object`
      Returns:
        the string itself.

    - #### toUpperCase

          public String toUpperCase()

      Converts all of the characters in this `String` to upper case using the rules of the default locale. This method is equivalent to `toUpperCase(Locale.getDefault())`.
      Returns:
        the `String`, converted to uppercase.

    - #### trim

          public String trim()

      Returns a copy of the string, with leading and trailing whitespace omitted.

      If this `String` object represents an empty character sequence, or the first and last characters of character sequence represented by this `String` object both have codes greater than `'\u0020'` (the space character), then a reference to this `String` object is returned.

      Otherwise, if there is no character with a code greater than `'\u0020'` in the string, then a new `String` object representing an empty string is created and returned.

      Otherwise, let k be the index of the first character in the string whose code is greater than `'\u0020'`, and let m be the index of the last character in the string whose code is greater than `'\u0020'`. A new `String` object is created, representing the substring of this string that begins with the character at index k and ends with the character at index m-that is, the result of `this.substring(k, m+1)`.

      This method may be used to trim whitespace (as defined above) from the beginning and end of a string.

      Returns:
        A copy of this string with leading and trailing white space removed, or this string if it has no leading or trailing white space.